% !TeX spellcheck = en_GB
%%%%%%%%%%%%%%%%%%%%% Packages calls %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\documentclass[british, a4paper, 10pt]{article}									%%
\usepackage[utf8]{inputenc}														%%
\usepackage[T1]{fontenc}														%%
\usepackage{textcomp}															%%
\usepackage{babel}																%%
\usepackage{lmodern}															%%
\usepackage[top=3cm, bottom=3cm, left=3cm, right=3cm]{geometry}					%%
\usepackage{fancyhdr}															%%
\usepackage{amsfonts}															%%
\usepackage{mathtools}															%%
\usepackage{amssymb}															%%
\usepackage{hyperref}															%%
\usepackage{booktabs}															%%
\usepackage{graphicx}															%%
\usepackage{listings}															%%
\usepackage{color}																%%
\definecolor{dkgreen}{rgb}{0,0.6,0}												%%
\definecolor{gray}{rgb}{0.5,0.5,0.5}											%%
\definecolor{mauve}{rgb}{0.58,0,0.82}											%%
%%%%%%%%%%%%%%%%%%%%% Commands Definition %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\newcommand{\N}{\mathbb{N}}														%%
\newcommand{\Z}{\mathbb{Z}}														%%
\newcommand{\Q}{\mathbb{Q}}														%%
\newcommand{\R}{\mathbb{R}}														%%
\newcommand{\C}{\mathbb{C}}														%%
\renewcommand{\vec}{\overrightarrow}											%%
\newcommand{\Matlab}{\textsc{Matlab}}											%%
\newcommand{\barre}{\vspace{3pt}\hrule\vspace{6pt}}								%%
\newcommand{\HRule}{\rule{\linewidth}{0.5mm}}									%%
\author{\coauthorOne - \coauthorTwo}											%%
\title{\betitle}																%%
\hypersetup{bookmarks=true,														%%
			pdfborder={0 0 0},													%%
			pdftoolbar=false,													%%
			citecolor=blue		}												%%
\lstset{frame=tb,																%%
		language=Python,														%%
		aboveskip=3mm,															%%
		belowskip=3mm,															%%
		showstringspaces=false,													%%
		columns=flexible,														%%
		basicstyle={\small\ttfamily},											%%
		numbers=none,															%%
		numberstyle=\tiny\color{gray},											%%
		keywordstyle=\color{blue},												%%
		commentstyle=\color{dkgreen},											%%
		stringstyle=\color{mauve},												%%
		breaklines=true,														%%
		breakatwhitespace=true,													%%
		tabsize=4																%%
}																				%%
%%%%%%%%%%%%%%%%%%%%% Head and foot definition %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\pagestyle{fancy}																%%
	\lhead{\matiere}		\chead{}	\rhead{\betitle}						%%
	\renewcommand{\headrulewidth}{0.4pt}										%%
	\renewcommand{\footrulewidth}{0.4pt}										%%
	\lfoot{\coauthorOne}\cfoot{\thepage/\pageref{LastPage}}	\rfoot{\coauthorTwo}%%
																				%%
\fancypagestyle{plain}{															%%
	\lhead{}	\chead{}	\rhead{}											%%
	\renewcommand{\headrulewidth}{0pt}											%%
	\renewcommand{\footrulewidth}{0pt}											%%
	\lfoot{}	\cfoot{}	\rfoot{}}											%%
%%%%%%%%%%%%%%%%%%%%% Title page %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\newcommand{\maketitlepage}{													%%
	\begin{titlepage}															%%
		\pagestyle{plain}														%%
		\begin{large}															%%
			\begin{center}														%%
				\textsc{\LARGE \matiere}\\[1.5cm]								%%
																				%%
				\textsc{\Large \group}\\[0.5cm]									%%
																				%%
				\HRule \\[0.4cm]												%%
				{\huge \bfseries \betitle  \\[0.4cm]}							%%
				\HRule \\[1.5cm]												%%
																				%%
				\noindent														%%
				\begin{minipage}{0.4\textwidth}									%%
					\begin{flushleft} \large									%%
						\emph{Students:}\\										%%
						\coauthorOne											%%
					\end{flushleft}												%%
				\end{minipage}													%%
				\begin{minipage}{0.4\textwidth}									%%
					\begin{flushright} \large									%%
						\emph{Teachers:}\\										%%
						\teacherOne												%%
					\end{flushright}											%%
				\end{minipage}\\												%%
				\medskip														%%
																				%%
				\noindent														%%
				\begin{minipage}{0.4\textwidth}									%%
					\begin{flushleft} \large									%%
						\coauthorTwo											%%
					\end{flushleft}												%%
				\end{minipage}													%%
				\begin{minipage}{0.4\textwidth}									%%
					\begin{flushright} \large									%%
						\teacherTwo												%%
					\end{flushright}											%%
				\end{minipage}\\												%%
																				%%
				\vspace{2\baselineskip}  										%%
				{\Large \duedate}												%%
			\end{center}														%%
			\vfill																%%
			\begin{large}														%%
				\introText														%%
			\end{large}															%%
		\end{large}																%%
		\tableofcontents														%%
		\newpage
		$~$ \newpage
	\end{titlepage}																%%
																		%%
}																				%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%% Doc Info %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\newcommand{\betitle}		{Lab Report : Voice recognition}					%%
\newcommand{\matiere}		{ENG5027 - Digital Signal Processing}			  	%%
\newcommand{\coauthorOne}	{R\'emy \textsc{Chatel} 	\\ 2411062C}			%%
\newcommand{\coauthorTwo}	{Chiemeka \textsc{Aguwamba} \\ 2409785A}			%%
\newcommand{\teacherOne}	{Bernd \textsc{Porr} \\ $~$}						%%
\newcommand{\teacherTwo}	{$~$}												%%
\newcommand{\duedate}		{Due October, 22nd 2018}							%%
\newcommand{\group}			{University of Glasgow}								%%
\newcommand{\introText}		{													%%
\paragraph*{}																	%%
}																				%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\begin{document}	
\maketitlepage

\section{Voice recording and filtering}
\subsection{Motivation}
\paragraph{}
When recording with a microphone, a large number of degradations to th signal occur. First, the ambient noise will pollute the useful part of it, then the microphone will have a specific response to different frequencies, further altering the signal. The sound card of the device used for the recording will also have its own frequency response and the cut off frequency may sometime be surprisingly low. 

\paragraph{}
For those reasons, processing the recorded audio is highly recommended before using it (broadcasting, music recording, ...).

\paragraph{}
Recording with the built-in microphone of a standard computer resulted in a low quality recording : the signal was noisy and the sound-card cut-off frequency was at $9~kHz$ meaning the actual bandwidth of the recorded signal was narrow.

Therefore all the audio files used in this assignment were recorded using the provided dedicated microphone (see Figure \ref{fig:sm58} for its frequency response) on computer which sound card yielded a higher cut-off frequency of $15~kHz$.

\begin{figure}[hbp]
	\centering
	\includegraphics[trim = 308 145 88 500, clip]{../doc/sm58.pdf}
	\caption{Frequency response - extract from SHURE's SM58 datasheet}
	\label{fig:sm58}
\end{figure}

\paragraph{}
The following sentence was recorded to be processed : "If the rocket launch fails, we can always abort". The result of this recording and its spectrum are shown on Figure \ref{fig:original} page \pageref{fig:original}.

\begin{figure}[hbp]
	\centering
	\includegraphics[width=0.7\linewidth]{../outputs/Original.pdf}
	\caption{Recording of the sentence in the time and frequency domains}
	\label{fig:original}
\end{figure}

\noindent The recording was done using the {\tt sox} console tool with the following arguments :

\lstinline|sox -t waveaudio -d original.wav|

\noindent This gives us a 2-channel recording in encoded in int16 at a sampling frequency of $48~Hz$

\subsection{Implementation}

The flowchart of the process is described Figure \ref{fig:flow} page \pageref{fig:flow}.

\begin{figure}[htp]
	\centering
	\includegraphics[width=\linewidth]{flowchart.pdf}
	\caption{Flow chart of the task}
	\label{fig:flow}
\end{figure}

\subsubsection{Tools}
The main tool of this exercise is the Fourier transform and in particular the Fast Fourier Transform algorithm. It allows us to quickly compute the spectrum of a signal, transform it and then return to the time domain.

We will use the FFT algorithm provided by Numpy in \lstinline|numpy.fft.fft|.

To make the program more clear, the audio sample is represented by a class called Voice that holds the signal, its fft and all the tools to process it. See Appendix page \pageref{cod:voice}. 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
•	To test our fft enhancer, we tested different input values of f\_low, f\_high and dB gain factor to enhance our voice output. We used the write() function to write the “enhanced.wav” and played it back to check sound quality. 
•	We plotted the figure 4 and 5 which are the time domain and frequency domain plots of the “enhanced.wav” respectively.

\subsubsection{Custom filter}
\paragraph{}
We identified and developed the key functions needed to enhance our recorded audio. We defined a class object called Voice. The Voice class is saved in a module called voice.py. The module has class functions which are: \texttt{setDC (), cut\_band(), gaindB(), update(), print(), write()}. Refer Appendix page \pageref{cod:voice} for details of the Voice class codes and syntax. 

\begin{itemize}
\item	The \texttt{setDC()} takes care of the DC at index value 0.  

\item	The \texttt{cut\_band()} function cuts off the |0-50Hz| and |15kHz to Nyquist frequency which are outside the frequency response of the SM98 microphone. The stop band parameters: f\_low and f\_high are boundary frequencies of the unwanted region. Example:  for $|15kHz-f_{Nyquist}|, f_{low} =15000, f_{high}=48000/2$

\item	The \texttt{gaindB()} class function simulates our equalizer. The input parameters are: gain factor in dB, f\_low and f\_high. A positive value gain factor implies amplification, 0dB for unity gain , and negative value dB for attenuation. f\_low and f\_high are equalizer frequency bands of interest where we want to enhance the sound output by tweaking the gain factor. 
The \texttt{gaindB()} function also works out the equivalent index sample that corresponds to f\_low and f\_high, in the frequency domain.
\[
i_{index} = f_{low} * n_{samples}/ F_s
\]
\[
i_{index} = f_{low} * n_{samples}/ F_s
\]
\end{itemize}

\begin{lstlisting}
def gaindB(self, gain, f_low, f_high):
	"""
	Apply a gain (in dB) to a frequency domain signal between two boundaries
	frequencies.
	
	Parameters
	----------
	gain : dtype
	The amplification gain. Should be of the same type as the data array
	f_min : float
	Low cut-off frequency of the amplification
	f_max : float
	High cut-off frequency of the amplification
	
	Yields
	------
	The FFT of the signal is now modified according to this gain
	"""
	i_min = int(self.L * f_low / self.Fs)           # Mapping index to frequencies
	i_max = int(self.L * f_high/ self.Fs)
	gain = 10**(gain/20)                            # Converting to linear
	
	for i in range(i_min, i_max+1):                 # Applying gain to spectrum
		self.sig_fft[i] = self.sig_fft[i]*gain      # before F_sampling/2
	
	if i_min == 0:
		self.sig_fft[-1] = self.sig_fft[-1]*gain    # aking care of the zero index
	i_min += 1
	
	for i in range(self.L-i_max,self.L-i_min+1):    # Applying gain to the 
		self.sig_fft[i] = self.sig_fft[i]*gain      # spectrum after F_sampling/2
	self.hasChanged = 1
	return
\end{lstlisting}

\subsubsection{Test program}
\paragraph{} The test program \texttt{fft\_enhancer.py} imports a file (here called \texttt{original.wav}) apply a set of filter and transformations and write back to \texttt{improved.wav}. See Appendix page \pageref{cod:fft} for detailed implementation.

The transformation have been chosen according to common practice in vocal equalizing as depicted on the website \url{https://www.behindthemixer.com/how-to-eq-vocals-in-six-easy-steps/}.

\subsection{Conclusion}
\subsubsection{Results}

The result of the enhancement through FFT transform is pictured on Figure \ref{fig:out}. We can observe the effect of the effect of the low-pass filter that removed all frequencies above $15~kHz$.

\begin{figure}[htp]
	\centering
	\includegraphics[width=\linewidth]{../outputs/Original.pdf}
	\caption{Input of the fft\_enhancer}
	\label{fig:in}
\end{figure}

\begin{figure}[htp]
	\centering
	\includegraphics[width=\linewidth]{../outputs/Improved.pdf}
	\caption{Output of the fft\_enhancer}
	\label{fig:out}
\end{figure}

The output file sounds different but whether it sounds better is difficult to say. Most of the background noise being due to chatting in the distance, it was impossible to remove it without affecting the main information. 

However the audio enhancer was successful in eliminated low frequency bass noise. It was programmed to offer the user the flexibility to enhance the audio voice, by inputting any gain factor (dB) and selecting targeted frequency range of interest (f\_low and f\_high).

It’s worth bearing in mind that other factors could influence the judgement of the quality of the enhanced audio sound, when played back. For example the cut-off frequency limitation of our PC or laptop sound cards can vary from model to model


\subsubsection{Comments}

\paragraph{}
This part of the assignment showed us how important the set up was important for audio recording. The hardware used : the microphone, its frequency response, its directivity, the sound-card and its ADC, echo reduction, ...

We learn that having a high sampling frequency is useless if the hardware is not good enough to provide the harmonics up to the sampling frequency.


\section{Speech detection}
\subsection{Motivation}
\paragraph{}Voice assistants are becoming common place with the release of devices such as Alexa or Google Home Assistant. Even our computers and smartphone are now coming with a built-in voice assistant (Syri or Cortana).

\paragraph{} The objective of the second part of this assignment is to try to recreate a speech detection program that can react to command words using the Fourier Transform.

\subsection{Implementation}

\begin{figure}[htp]
	\centering
	\includegraphics[width=\linewidth, clip, trim = 1 1 1 1]{class_diagram.pdf}
	\caption{Class diagram of the program}
	\label{fig:class}
\end{figure}

\subsubsection{Word definition}
\paragraph{} In order to detect a word, it has to be first defined in a way the program will be able to discriminate two different words and match two similar words.

\paragraph{} A syllable matching has been chosen : the word is sliced into chunk of fixed width to show the different syllable it is made of. Then each syllable is defined by its fundamental frequency (the frequency of maximum amplitude in the spectrum of the syllable). Therefore the main idea is to apply the Fourier transform to the syllable in order to have its spectrum. Then find the frequency of maximum amplitude.

\paragraph{} The following definition of a word has been translated into the code the following way :
\begin{itemize}
	\item A Voice class from the first part of the assignment
	\item A Syllable class that contains an audio sample and the related fundamental frequency
	\item A Word class contains the audio recording in a Voice object, slices it and places the result in a list of Syllable objects.
\end{itemize}

\begin{lstlisting}[]
class Voice:
	"""	Contains an audio sample and its Fourier transform
	Allows to perform filtering operations on the spectrum of the signal """

class Syllable:
	"""	Contains an audio sample and its Fourier transform
	Allows to perform a fundamental frequency search to define the syllable	"""

class Word:
	"""	Contains a Voice recording and a list of Syllables
	Represents a word, can slice it into syllables	"""
\end{lstlisting}

The search for the fundamental frequency has been implemented in the following way : the index of the maximum amplitude is found then mapped to its equivalent in the frequency axis.

\begin{lstlisting}
def fundamental(self):
	"""
	Find the fundamental frequency (as frequency of maximum amplitude)
	"""
	self.f_fundamental = 0                              		# Init variables
	self.i_fundamental = 0                                  
	a_max = np.max(np.abs(self.fft[:self.L//2]))          		# Find the max value
	for k in range(1,self.L//2):                            	# Read the array
	if np.abs(self.fft[k]) == a_max:                    		# Until max is found
	self.i_fundamental = k                         				# Record index of max
	self.f_fundamental = self.i_fundamental*self.Fs/self.L  	# Map k to the Frequency axis
	self.A_fundamental= np.abs(self.fft[self.i_fundamental])	# Record max amplitude
	return self.f_fundamental
\end{lstlisting}

\subsubsection{Word matching}
\paragraph{} Before comparing words, they have to be prepared for processing. That means trimming the word by removing the blanks before and after the word, using a detection threshold. Then the width of the syllable must be defined in the same way for the two words.

A slicing function and a trimming function have been implemented as methods of the Word class. See Appendix page \pageref{cod:word}

\paragraph{} They are broken down into those syllables and the lists of fundamental frequencies therefore obtained is used to decide if the reference word exist within the list of syllables of the tested word. 

This operation boils down to substracting the list of fundamentals of the reference to the list of the tested word. If the every value of the resulting list is within the tolerance, a match is considered to have been found : $\|f_{ref} - f_{test}\|\leq tolerance$ for every syllable

\begin{lstlisting}
def compare(self, reference, tolerance):
	isSame = False                          			# Initialising the boolean
	length = len(reference)  							# Getting the length of ref
	if length == len(self.fundamentals):    			# Taking care of equal length
		test_array = np.abs(self.fundamentals-reference)
		if np.max(test_array) < tolerance:
			isSame = True
	else:                                   			# Otherwise, roll through list
		for i in range(len(self.fundamentals)-length):	# Dealing with variable width
			# making the array of the difference between the ref and the word
			test_array = np.abs(self.fundamentals[i:i+length]-reference)
			if np.max(test_array) < tolerance:  		# If all freq are within tolerance
				isSame = True                   		# Set the boolean to True
	return isSame
\end{lstlisting}

\subsection{Conclusion}
\subsubsection{Results}
\paragraph{} Although the process appears reasonably simple, the implementation was still challenging. Mainly because of the sensitivity of the fundamental search to the width of the chunk and the detection threshold. 

Another python script ({\tt speech\_analysis.py}) had to be written to have informations on the processing operations and tweak them until it worked. The result was the following :

\begin{lstlisting}
launch_r0.wav:
[388 231]
Length : 0.5185 s

launch_r2.wav:
[391 173]
Length : 0.6040833333333333 s

abort_r0.wav:
[511 138]
Length : 0.5012708333333333 s

abort_r1.wav:
[491 224]
Length : 0.537125 s

abort_r2.wav:
[497 134]
Length : 0.5131875 s

sentence_r.wav:
[ 120  160  125  388  131 4731  102  114  200  120  120  177  188  194 200  211  108  405  211  440  468  160  171  200]
Length : 4.169770833333334 s
\end{lstlisting}

In this printout of the console we can see that both words appears in the sentence : "Launch" with $ [388, 131] $ close to the $ [391, 173] $ of the reference word.

In a similar way, we can detect the "Abort" word $ [497, 134] $ later in the sentence.

\paragraph{}
To test the main program {\tt alexa\_light.py}, the result is printed in the console. To test it, the two reference words are tested against themselves to check that that have been imported correctly. Then the next two tests are a completely different word ("Glasgow") then another recording of the word "abort".

The following printout was obtained :

\begin{lstlisting}
Testing "launch" against the library
Detected word :         Launch  

Testing "abort" against the library
Detected word :         Abort   

Testing "Glasgow" against the library
Detected word :         No match

Testing another "abort": abort_test.wav
Detected word :         Abort  
\end{lstlisting}


\subsubsection{Comments}
\paragraph{}
The word detection have been successfully implemented using the Fourier transform of the syllables.

However the sensitivity to the syllable width and to the threshold makes it hard to use with a full sentence reliably and we see here the reasons to use more efficient methods such as matched filter or general FIR filter. 

\newpage
\appendix
\section{Codes}
\noindent All source files can be found at the following url : \url{https://gitlab.com/r.chatel/uog_dsp}

\paragraph{Source files} :

\noindent Voice class
\lstinputlisting{../voice.py}
\label{cod:voice}
\noindent Word class
\lstinputlisting{../word.py}
\label{cod:word}
\noindent Syllable class
\lstinputlisting{../syllable.py}
\label{cod:syllable}
\noindent FFT enhancer main program
\lstinputlisting{../fft_enhancer.py}
\label{cod:fft}
\noindent Alexa-like word detection
\lstinputlisting{../alexa_light.py}
\label{cod:alexa}

\label{LastPage}
\end{document}
